package game;

import java.util.ArrayList;

import main.TestGame;

public abstract class Entity {
	//Common data bits.

	public int xPosition;
	public int yPosition;
	
	protected ArrayList<Integer> xs = new ArrayList<Integer>();
	protected ArrayList<Integer> ys = new ArrayList<Integer>();
	protected ArrayList<Integer> rs = new ArrayList<Integer>();

	//Properties
	
	public abstract int getEntitySize();
	
	//Selection codes.
	
	private boolean isSelected;
	
	public boolean isSelected() {
		return isSelected;
	}
	
	public void selectionDraw(int[] data, int xOffset, int yOffset) {
		for (int x = xPosition - getEntitySize() + xOffset; x <= xPosition + getEntitySize() + xOffset; x++) {
			for (int y = yPosition - getEntitySize() + yOffset; y <= yPosition + getEntitySize() + yOffset; y++) {
				if (x == xPosition + xOffset && y == yPosition + yOffset)
					continue;
				if (x < 0 || y < 0 || x >= TestGame.WIDTH || y >= TestGame.HEIGHT)
					continue;
				data[y * TestGame.WIDTH + x] = getSelectCursorColor();
			}
		}
	}
	
	public abstract int getSelectCursorColor();
	
	//Drawing
	
	public void circleDraw(int[] data, int cx, int cy, int radius, int xOffset, int yOffset) {
		for (double i = 0; i < Math.PI * 2; i += 0.1) {
			int x = (int) (Math.rint(Math.cos(i) * radius) + xOffset + cx);
			int y = (int) (Math.rint(Math.sin(i) * radius) + yOffset + cy);
			if (x < 0 || y < 0 || x >= TestGame.WIDTH || y >= TestGame.HEIGHT)
				continue;
			data[y * TestGame.WIDTH + x] = 0xFFFFFFFF;
		}
	}
	
	public void setCircleDrawCenter(int x, int y) {
		xs.add(x);
		ys.add(y);
	}
}
