package game;

import main.TestGame;

public class Mob extends Entity {
	public final int colorFlag = 0xFFCCFFAA;
	
	private int step = 0;
	private int oldX;
	private int oldY;
	
	public Mob(int x, int y) {
		xPosition = x;
		yPosition = y;
		oldX = x;
		oldY = y;
	}
	
	public void attack(TestGame game, Player player, int diff) {
		step++;
		if (step > diff) {
			step = 0;
			//tick updates
			move(player);
		}
	}
	
	public void draw(World world, int[] data) {
		//data[(oldY + world.y) * TestGame.WIDTH + (world.x + oldX)] = 0;
		data[(world.y + yPosition) * TestGame.WIDTH + (world.x + xPosition)] = colorFlag;
	}
	
	private void move(Player player) {
		oldX = this.xPosition;
		oldY = this.yPosition;
		
		double dx = player.xPosition - this.xPosition;
		double dy = player.yPosition - this.yPosition;
		
		double dist = Math.sqrt(dx * dx + dy * dy);
		//if (dist > 0) {
			dx /= dist;
			dy /= dist;
		//}
		this.xPosition += (int) (Math.rint(dx));
		this.yPosition += (int) (Math.rint(dy));
	}
	
	@Override
	public int getEntitySize() {
		return 1;
	}
	
	@Override
	public int getSelectCursorColor() {
		return 0xFFAA0000;
	}
}
