package main;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

public class Input implements KeyListener, MouseListener {
	public boolean[] keys = new boolean[65536];
	public boolean leftMouseButton, rightMouseButton;
	public int mouseX, mouseY;

	@Override
	public void keyPressed(KeyEvent e) {
		int code = e.getKeyCode();
		if (code > 0 && code < keys.length) {
			keys[code] = true;
		}
	}

	@Override
	public void keyReleased(KeyEvent e) {
		int code = e.getKeyCode();
		if (code > 0 && code < keys.length) {
			keys[code] = false;
		}
	}

	@Override
	public void keyTyped(KeyEvent e) {
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {
		switch (arg0.getButton()) {
			case MouseEvent.BUTTON1:
				leftMouseButton = true;
				break;
			case MouseEvent.BUTTON3:
				rightMouseButton = true;
				break;
		}
		mouseX = arg0.getX() / TestGame.SCALE;
		mouseY = arg0.getY() / TestGame.SCALE;
	}
	
	@Override
	public void mouseEntered(MouseEvent arg0) {
	}
	
	@Override
	public void mouseExited(MouseEvent arg0) {
	}
	
	@Override
	public void mousePressed(MouseEvent arg0) {
		switch (arg0.getButton()) {
			case MouseEvent.BUTTON1:
				leftMouseButton = true;
				break;
			case MouseEvent.BUTTON3:
				rightMouseButton = true;
				break;
		}
		mouseX = arg0.getX() / TestGame.SCALE;
		mouseY = arg0.getY() / TestGame.SCALE;
	}
	
	@Override
	public void mouseReleased(MouseEvent arg0) {
		switch (arg0.getButton()) {
			case MouseEvent.BUTTON1:
				leftMouseButton = false;
				break;
			case MouseEvent.BUTTON3:
				rightMouseButton = false;
				break;
		}
	}

}
